"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseStorageService = void 0;
var foundation_1 = require("../foundation");
;
var BaseStorageService = /** @class */ (function () {
    function BaseStorageService() {
        this._s3StorageConnect = foundation_1.S3StorageConnect.getInstance();
        this._storage = this._s3StorageConnect.storage;
        this._nconf = foundation_1.Nconf.getInstance();
    }
    ;
    // private _streamToString(stream: any): Promise<ArrayBuffer> {
    //     return new Promise((resolve, reject) => {
    //         const chunks: any[] = [];
    //         stream.on('data', (chunk: any) => chunks.push(chunk));
    //         stream.on('error', reject);
    //         stream.on('end', () => {
    //             return resolve(Buffer.concat(chunks));
    //         });
    //     });
    // }
    /**
     *
     * @param key example path : 'output.zip'
     * @param expires
     * @param objType
     * @param contentType getObject | putObject
     * @description To get signedURL for viewing and updating an object.
     * @returns Promise<string>
     */
    BaseStorageService.prototype.getSignedURL = function (key, expires, objType) {
        if (expires === void 0) { expires = this._nconf.nconf.get('getSignedURLExpiry'); }
        if (objType === void 0) { objType = 'getObject'; }
        return __awaiter(this, void 0, void 0, function () {
            var signedURLRes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._storage.getSignedUrlPromise(objType, {
                            Bucket: this._s3StorageConnect.bucketName,
                            Key: key,
                            Expires: expires,
                            // ContentType: contentType
                        })];
                    case 1:
                        signedURLRes = _a.sent();
                        return [2 /*return*/, signedURLRes];
                }
            });
        });
    };
    ;
    /**
     *
     * @param fileURL example: https://s3.terrahost.com/bucketName/public/users/user_id/avatar/model.zip?someQuery=someValue&someOtherQuery=someOtherValue
     * @returns example: https://s3.terrahost.com/bucketName/public/users/user_id/avatar/model.zip
     */
    BaseStorageService.prototype.getPlainFileURL = function (fileURL) {
        if (!fileURL)
            return fileURL;
        var url = new URL(fileURL);
        fileURL = url.origin + url.pathname;
        return fileURL;
    };
    ;
    /**
     *
     * @param fileURL example: https://s3.terrahost.com/bucketName/public/users/user_id/avatar/model.zip
     * @returns example: public/users/user_id/avatar/model.zip
     */
    BaseStorageService.prototype.getObjectKey = function (fileURL) {
        return fileURL.split(this._s3StorageConnect.baseFilePath)[1];
    };
    ;
    /**
     *
     * @param key example: /public/users/user_id/avatar/model.zip
     * @returns Lock will be added for the particular object.
     */
    BaseStorageService.prototype.addObjectLock = function (key) {
        var _this = this;
        var promise = new Promise(function (resolve, reject) {
            _this._storage.putObjectLegalHold({
                Bucket: _this._s3StorageConnect.bucketName,
                Key: key,
                LegalHold: {
                    Status: "ON"
                },
            }, function (err, data) {
                if (err)
                    return reject(err);
                resolve(data);
            });
        });
        return promise;
    };
    ;
    /**
     *
     * @param key example: /public/users/user_id/avatar/model.zip
     * @returns Lock will be removed for the particular object.
     */
    BaseStorageService.prototype.removeObjectLock = function (key) {
        var _this = this;
        var promise = new Promise(function (resolve, reject) {
            _this._storage.putObjectLegalHold({
                Bucket: _this._s3StorageConnect.bucketName,
                Key: key,
                LegalHold: {
                    Status: "OFF"
                },
            }, function (err, data) {
                if (err)
                    return reject(err);
                resolve(data);
            });
        });
        return promise;
    };
    ;
    BaseStorageService.prototype.getObject = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var promise, file;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        promise = new Promise(function (resolve, reject) {
                            _this._storage.getObject({
                                Bucket: _this._s3StorageConnect.bucketName,
                                Key: key,
                            }, function (err, data) {
                                if (err)
                                    reject(err);
                                console.log('data ::: arrayBuffer ::', data);
                                resolve(data);
                            });
                        });
                        return [4 /*yield*/, promise];
                    case 1:
                        file = _a.sent();
                        return [2 /*return*/, file.Body];
                }
            });
        });
    };
    ;
    BaseStorageService.prototype.putObject = function (key, body) {
        return __awaiter(this, void 0, void 0, function () {
            var promise;
            var _this = this;
            return __generator(this, function (_a) {
                promise = new Promise(function (resolve, reject) {
                    _this._storage.putObject({
                        Bucket: _this._s3StorageConnect.bucketName,
                        Key: key,
                        Body: body
                    }, function (err, data) {
                        if (err)
                            reject(err);
                        resolve(data);
                    });
                });
                return [2 /*return*/, promise];
            });
        });
    };
    ;
    return BaseStorageService;
}());
exports.BaseStorageService = BaseStorageService;
;
